Unit QS18R_p;
interface
uses
SysUtils, Math, { Delphi }
Lstruct, Lfunc, UTQS11_p;

procedure QS18R(var RINT :Real; A :Real; B :Real; F :Func_F1; W :Real;
                FI :Real; E :Real; L :Integer; var RA :Array of Real;
                var RB :Array of Real; var IERR :Integer);

implementation

procedure QS18R(var RINT :Real; A :Real; B :Real; F :Func_F1; W :Real;
                FI :Real; E :Real; L :Integer; var RA :Array of Real;
                var RB :Array of Real; var IERR :Integer);
var
I,I0,I1,J,K,K0,M,N,N0,N1,N2 :Integer;
A0,B0,E0,H,Q,Q0,QJ,R,R0,R1,R2,RA1,RA2,RB1,RB2,RI,RJ,X0,X1,XA,XA0,XB,
   XB0 :Real;
C :Array [0..15] of Real;
X :Array [0..15] of Real;
const
PI :Real = 3.14159265359;
label
_10,_20,_30,_40,_50,_60,_70,_80,_90,_100,_110,_120,_130,_140,_150,
_160,_170,_180,_190,_200,_210,_220,_230,_240;
begin
{   DATA  FORTRAN  }
X[0] := 0.498631930925;
X[1] := 0.492805755773;
X[2] := 0.482381127794;
X[3] := 0.467453037969;
X[4] := 0.448160577883;
X[5] := 0.424683806866;
X[6] := 0.397241897984;
X[7] := 0.36609105937;
X[8] := 0.331522133465;
X[9] := 0.29385787862;
X[10] := 0.253449954466;
X[11] := 0.210675638065;
X[12] := 0.165934301141;
X[13] := 0.119643681126;
X[14] := 0.072235980791;
X[15] := 0.024153832844;
C[0] := 0.003509305005;
C[1] := 0.008137197365;
C[2] := 0.012696032655;
C[3] := 0.017136931457;
C[4] := 0.021417949011;
C[5] := 0.025499029631;
C[6] := 0.029342046739;
C[7] := 0.032911111388;
C[8] := 0.036172897054;
C[9] := 0.039096947894;
C[10] := 0.041655962113;
C[11] := 0.043826046502;
C[12] := 0.045586939348;
C[13] := 0.04692219954;
C[14] := 0.04781936004;
C[15] := 0.048270044257;
Q := W;
R := FI;
N := L;
IERR := 0;
if ( B - A ) < 0
 then goto _10
 else if ( B - A ) > 0
       then goto _30
       else goto _20;
_10:
A0 := B;
B0 := A;
J := -1;
goto _40;
_20:
RINT := 0.0;
K := 0;
goto _240;
_30:
A0 := A;
B0 := B;
J := 1;
_40:
if ( Q  >=  0.0 ) 
 then goto _50;
QJ := -Q;
RJ := -R;
J := -J;
goto _60;
_50:
QJ := Q;
RJ := R;
_60:
Q0 := QJ/PI;
R0 := RJ/PI;
R1 := Q0*A0 + R0;
N1 := Trunc(R1);
if ( R1  >=  0.0 ) 
 then N1 := N1 + 1;
R2 := Q0*B0 + R0;
N2 := Trunc(R2);
if ( R2  <  0.0 ) 
 then N2 := N2 - 1;
N0 := N2 - N1;
K := N0 + 1;
if ( N0  >=  1 ) 
 then goto _70;
H := B0 - A0;
X1 := A0 + 0.5*H;
RINT := 0.0;
M := 220;
goto _200;
_70:
H := PI/QJ;
XA0 := H*N1 - RJ/QJ;
XB0 := XA0 + H*N0;
if ( N0  >=  2 ) 
 then goto _90;
X1 := XA0 + 0.5*H;
M := 80;
goto _200;
_80:
RINT := RI;
goto _170;
_90:
if ( K  >  N ) 
 then K := N;
XA := XA0;
X1 := XA + 0.5*H;
M := 100;
goto _200;
_100:
RA[0] := RI;
RA[1] := 0.5*RI;
RA1 := RI;
XB := XB0;
X1 := XB - 0.5*H;
M := 110;
goto _200;
_110:
RB[0] := RI;
RB[1] := 0.5*RI;
RB1 := RI;
//
I := 3;
while I<=K do
 begin
  K0 := I;
  XA := XA + H;
  X1 := XA + 0.5*H;
  M := 120;
  goto _200;
_120:
  RA[0] := RA[0] + RI;
  RA[I-1] := RA[0];
  XB := XB - H;
  X1 := XB - 0.5*H;
  M := 130;
  goto _200;
_130:
  RB[0] := RB[0] + RI;
  RB[I-1] := RB[0];
  for I1:=2 to I do
   begin
    I0 := I1;
    RA2 := RA[I1-1];
    RA[I1-1] := 0.5*(RA[I1-2] + RA1);
    RB2 := RB[I1-1];
    RB[I1-1] := 0.5*(RB[I1-2] + RB1);
    E0 := Abs(RA[I1-1] - RA1) + Abs(RA[I1-2] - RA1) +
    Abs(RB[I1-1] - RB1) + Abs(RB[I1-2] - RB1);
    if ( E0  <=  E )
     then goto _160;
    RA1 := RA2;
    RB1 := RB2;
_140:
   end;
_150:
  inc(I);
 end;
IERR := 65;
UTQS11(IERR,15);
_160:
RINT := RA[I0-1] + RB[I0-1];
K := K0;
_170:
H := XA0 - A0;
if ( H  <=  0.0 )
 then goto _190;
X1 := A0 + 0.5*H;
M := 180;
goto _200;
_180:
RINT := RINT + RI;
_190:
H := B0 - XB0;
if ( H  <=  0.0 )
 then goto _230;
X1 := B0 - 0.5*H;
M := 220;
_200:
RI := 0.0;
for I1:=1 to 16 do
 begin
  X0 := H*X[I1-1];
  RI := RI + C[I1-1]*(F(X1+X0)*Sin(QJ*(X1+X0) + RJ) + F(X1-X0)*
    Sin(QJ*(X1-X0) + RJ));
_210:
 end;
RI := H*RI;
if ( M=80 ) then goto _80 else
if ( M=100 ) then goto _100 else
if ( M=110 ) then goto _110 else
if ( M=120 ) then goto _120 else
if ( M=130 ) then goto _130 else
if ( M=180 ) then goto _180 else
if ( M=220 ) then goto _220 else
if ( M=230 ) then goto _230;
_220:
RINT := RINT + RI;
_230:
RINT := RINT*J;
_240:
end;

end.
